pcl::FilterIndices< PointT > Class Template Referenceabstract
Module filters

FilterIndices represents the base class for filters that are about binary point removal. More...

`#include <pcl/filters/filter_indices.h>`

Inheritance diagram for pcl::FilterIndices< PointT >:

## Public Types

typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | applyFilter (std::vector< int > &indices)=0
| Abstract filter method for point cloud indices. More...
virtual void | applyFilter (PointCloud &output)=0
| Abstract filter method for point cloud. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::FilterIndices< PointT >

FilterIndices represents the base class for filters that are about binary point removal.

All derived classes have to implement the filter (PointCloud &output) and the filter (std::vector<int> &indices) methods. Ideally they also make use of the negative_, keep_organized_ and extract_removed_indices_ systems. The distinguishment between the negative_ and extract_removed_indices_ systems only makes sense if the class automatically filters non-finite entries in the filtering methods (recommended).

Author
  Justin Rosen

Definition at line 75 of file filter_indices.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

typedef boost::shared_ptr< const FilterIndices<PointT> > pcl::FilterIndices< PointT >::ConstPtr

Definition at line 82 of file filter_indices.h.

## PointCloud

template<typename PointT>

typedef pcl::PointCloud<PointT> pcl::FilterIndices< PointT >::PointCloud

Definition at line 79 of file filter_indices.h.

## Ptr

template<typename PointT>

typedef boost::shared_ptr< FilterIndices<PointT> > pcl::FilterIndices< PointT >::Ptr

Definition at line 81 of file filter_indices.h.

## Constructor & Destructor Documentation

## FilterIndices()

template<typename PointT>

pcl::FilterIndices< PointT >::FilterIndices | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 88 of file filter_indices.h.

## ~FilterIndices()

template<typename PointT>

virtual pcl::FilterIndices< PointT >::~FilterIndices | ( |  | ) |

inline virtual

Empty virtual destructor.

Definition at line 98 of file filter_indices.h.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT>

virtual void pcl::FilterIndices< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

protected pure virtual

Abstract filter method for point cloud indices.

Implemented in pcl::FrustumCulling< PointT >, pcl::ModelOutlierRemoval< PointT >, pcl::PassThrough< PointT >, pcl::PassThrough< PointInT >, pcl::CropBox< PointT >, pcl::NormalSpaceSampling< PointT, NormalT >, pcl::StatisticalOutlierRemoval< PointT >, pcl::RadiusOutlierRemoval< PointT >, pcl::CovarianceSampling< PointT, PointNT >, pcl::CropHull< PointT >, pcl::RandomSample< PointT >, pcl::ExtractIndices< PointT >, pcl::ShadowPoints< PointT, NormalT >, pcl::GridMinimum< PointT >, and pcl::LocalMaximum< PointT >.

Referenced by pcl::FilterIndices< PointInT >::filter().

## applyFilter() [2/2]

template<typename PointT>

virtual void pcl::FilterIndices< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected pure virtual

Abstract filter method for point cloud.

Implements pcl::Filter< PointT >.

Implemented in pcl::FrustumCulling< PointT >, pcl::ModelOutlierRemoval< PointT >, pcl::PassThrough< PointT >, pcl::PassThrough< PointInT >, pcl::CropBox< PointT >, pcl::NormalSpaceSampling< PointT, NormalT >, pcl::StatisticalOutlierRemoval< PointT >, pcl::RadiusOutlierRemoval< PointT >, pcl::CovarianceSampling< PointT, PointNT >, pcl::CropHull< PointT >, pcl::RandomSample< PointT >, pcl::ExtractIndices< PointT >, pcl::ShadowPoints< PointT, NormalT >, pcl::GridMinimum< PointT >, and pcl::LocalMaximum< PointT >.

## filter() [1/2]

template<typename PointT>

void pcl::FilterIndices< PointT >::filter | ( | PointCloud & | output | ) |

inline

Definition at line 103 of file filter_indices.h.

Referenced by pcl::people::GroundBasedPeopleDetectionApp< PointT >::compute(), pcl::FilterIndices< pcl::PCLPointCloud2 >::filter(), and pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::simplifyCloud().

## filter() [2/2]

template<typename PointT>

void pcl::FilterIndices< PointT >::filter | ( | std::vector< int > & | indices | ) |

inline

Calls the filtering method and returns the filtered point cloud indices.

Parameters

  [out] | indices | the resultant filtered point cloud indices

Definition at line 112 of file filter_indices.h.

## getKeepOrganized()

template<typename PointT>

bool pcl::FilterIndices< PointT >::getKeepOrganized | ( |  | ) |

inline

Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.

Returns
  The value of the internal keep_organized_ parameter; false = remove points (default), true = redefine points, keep structure.

Definition at line 156 of file filter_indices.h.

## getNegative()

template<typename PointT>

bool pcl::FilterIndices< PointT >::getNegative | ( |  | ) |

inline

Get whether the regular conditions for points filtering should apply, or the inverted conditions.

Returns
  The value of the internal negative_ parameter; false = normal filter behavior (default), true = inverted behavior.

Definition at line 136 of file filter_indices.h.

## setKeepOrganized()

template<typename PointT>

void pcl::FilterIndices< PointT >::setKeepOrganized | ( | bool | keep_organized | ) |

inline

Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.

Parameters

  [in] | keep_organized | false = remove points (default), true = redefine points, keep structure.

Definition at line 146 of file filter_indices.h.

Referenced by pcl::tracking::ParticleFilterTracker< PointInT, StateT >::ParticleFilterTracker().

## setNegative()

template<typename PointT>

void pcl::FilterIndices< PointT >::setNegative | ( | bool | negative | ) |

inline

Set whether the regular conditions for points filtering should apply, or the inverted conditions.

Parameters

  [in] | negative | false = normal filter behavior (default), true = inverted behavior.

Definition at line 127 of file filter_indices.h.

Referenced by pcl::people::GroundBasedPeopleDetectionApp< PointT >::compute().

## setUserFilterValue()

template<typename PointT>

void pcl::FilterIndices< PointT >::setUserFilterValue | ( | float | value | ) |

inline

Provide a value that the filtered points should be set to instead of removing them.

Used in conjunction with setKeepOrganized ().

Parameters

  [in] | value | the user given value that the filtered point dimensions should be set to (default = NaN).

Definition at line 166 of file filter_indices.h.

## Member Data Documentation

## keep_organized_

template<typename PointT>

bool pcl::FilterIndices< PointT >::keep_organized_

protected

False = remove points (default), true = redefine points, keep structure.

Definition at line 180 of file filter_indices.h.

Referenced by pcl::PassThrough< pcl::PCLPointCloud2 >::getFilterLimitsNegative(), pcl::FilterIndices< PointInT >::getKeepOrganized(), pcl::PassThrough< pcl::PCLPointCloud2 >::getKeepOrganized(), pcl::FilterIndices< pcl::PCLPointCloud2 >::getKeepOrganized(), pcl::FilterIndices< PointInT >::setKeepOrganized(), pcl::PassThrough< pcl::PCLPointCloud2 >::setKeepOrganized(), and pcl::FilterIndices< pcl::PCLPointCloud2 >::setKeepOrganized().

## negative_

template<typename PointT>

bool pcl::FilterIndices< PointT >::negative_

protected

False = normal filter behavior (default), true = inverted behavior.

Definition at line 177 of file filter_indices.h.

Referenced by pcl::PassThrough< PointInT >::getFilterLimitsNegative(), pcl::FilterIndices< PointInT >::getNegative(), pcl::FilterIndices< pcl::PCLPointCloud2 >::getNegative(), pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::getNegative(), pcl::PassThrough< PointInT >::setFilterLimitsNegative(), pcl::FilterIndices< PointInT >::setNegative(), pcl::FilterIndices< pcl::PCLPointCloud2 >::setNegative(), and pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::setNegative().

## user_filter_value_

template<typename PointT>

float pcl::FilterIndices< PointT >::user_filter_value_

protected

The user given value that the filtered point dimensions should be set to (default = NaN).

Definition at line 183 of file filter_indices.h.

Referenced by pcl::PassThrough< pcl::PCLPointCloud2 >::getFilterLimitsNegative(), pcl::FilterIndices< PointInT >::setUserFilterValue(), pcl::PassThrough< pcl::PCLPointCloud2 >::setUserFilterValue(), and pcl::FilterIndices< pcl::PCLPointCloud2 >::setUserFilterValue().

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/filters/include/pcl/filters/filter_indices.h